设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 4490|回复: 100

[源码] 三维多段线转换为带高程的二维多段线程序

  [复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2016-3-29 17:37:13 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
网上收集的。

  1. ;----------------------------------------------------------------------------------------------------------------------------------------------------------
  2. ;----------------------------------------------------------------------------------------------------------------------------------------------------------



  3. ;;;;;;;;;;;;;;;;;;;;;;;;;;三维多段线转换为带高程的二维多段线程序2.0;;;;;;;;;;;;;;;;;;;;;;
  4. ;;                                                                                     ;;
  5. ;;   1、本程序的功能为:把三维多段线转换为带高程的二维多段线。                          ;;
  6. ;;                                                                                     ;;
  7. ;;   2、程序主命令为"pl32",在命令行中输入"pl32"按提示使用即可。                        ;;
  8. ;;                                                                                     ;;
  9. ;;   3、程序要求必须全部为三维多段线,否则程序会出错!!!。                              ;;
  10. ;;                                                                                     ;;
  11. ;;   4、如果选择的不全是三维多段线,请用CAD下的快速选择命令选中全部三维多段线,        ;;
  12. ;;      然后再把这些对象转换到新的图层,并暂时关闭其它无关的图层,以方便选择,         ;;
  13. ;;      为此此程序不再详细编写选择集这部分。                                           ;;
  14. ;;                                                                                     ;;
  15. ;;   5、如果不想带高程,把程序中含有  gaocheng  的两行代码去掉就行了。                 ;;
  16. ;;                                                                                     ;;
  17. ;;   6、用户使用此程序前请做好备份!                                                    ;;
  18. ;;                                                                      2011.8.9       ;;
  19. ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  20. ;
  21. ;
  22. ;
  23. (defun c:pl32()                            ;程序名为pl32,把三维多段线转换为带高程的二维多段线,
  24.                                            ;
  25.   (VL-LOAD-COM)                            ;必要的加载函数
  26.                                            ;        
  27.   (setq AcadObject (vlax-get-acad-object))
  28.   (setq AcadDocument (vla-get-ActiveDocument Acadobject))
  29.   (setq mSpace (vla-get-ModelSpace Acaddocument))          ;此三行的作用是可以修改CAD文件了。
  30.   (prompt "\n <<请框选三维多段线,必须全部为三维多段线,否则程序会出错!!!>>")
  31.   (setq ss (ssget '((0 . "POLYLINE"))))   ;取得选择集,只把是三维和二维的多段线放到选择集中。
  32.   (if    ss                               ;判断选择集是否为空。
  33.         (progn
  34.               (setq n 0 k 0)              ;选择集的起始值n=0,完成更改的多段线数k=0。
  35.               (repeat (sslength ss)       ;计算选择集的对象个数。
  36.                 (setq en (ssname ss n))   ;依据索引值取出选择集中的图元名。
  37.                       (trans2d en)        ;调用转换三维到二维的子函数,此函数为执行函数。
  38.                       (setq k (1+ k))     ;转换完成的线数,完成一个加一。
  39.                       (setq n (1+ n))     ;
  40.                );repeat
  41.                (princ (strcat "\n 共有< " (itoa k) " >条三维多段线转换为二维多段线" ))
  42.          );progn
  43.          (prompt "\n <<您选择的对象中没有三维多段线,请重新执行此命令再进行选择!>>")
  44.    );if
  45.   (prin1)
  46. )
  47. ;
  48. ;
  49. ;

;trans2d函数代码如下:
游客,如果您要查看本帖隐藏内容请回复



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 5559个

财富等级: 富甲天下

发表于 2016-3-29 17:46:08 | 显示全部楼层
感谢楼主提供源码!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 604个

财富等级: 财运亨通

发表于 2016-3-30 08:48:08 | 显示全部楼层
感谢N版楼主提供源码!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 6530个

财富等级: 富甲天下

发表于 2016-3-30 09:37:39 | 显示全部楼层
先看看源码
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 6530个

财富等级: 富甲天下

发表于 2016-3-30 09:45:04 | 显示全部楼层
这个该试试命令convertpoly。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

点击这里给我发消息

已领礼包: 2959个

财富等级: 家财万贯

发表于 2016-3-30 10:20:06 | 显示全部楼层
回复学习学习,谢谢分享
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 859个

财富等级: 财运亨通

发表于 2016-3-30 18:06:57 | 显示全部楼层
三维线如果在一个平面上,求出各点在这个平面的投影坐标(2d)再构造 lwpolyline
投影到 WCS 只要去掉各点的 Z 值,用二维点构造 lwpolyline
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2个

财富等级: 恭喜发财

发表于 2016-4-3 14:25:51 | 显示全部楼层
感谢提供,学习
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

点击这里给我发消息

已领礼包: 6033个

财富等级: 富甲天下

发表于 2016-4-4 18:06:07 | 显示全部楼层
[size=14.1666660308838px]感谢大师提供源码学习!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2016-4-4 22:44:34 | 显示全部楼层
想看看,谢谢楼主
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 717个

财富等级: 财运亨通

发表于 2016-4-5 19:15:58 | 显示全部楼层
xuexie    xiexie  
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2016-8-26 18:34:24 | 显示全部楼层
谢谢版主共享:lol:lol
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

点击这里给我发消息

已领礼包: 193个

财富等级: 日进斗金

发表于 2016-9-5 17:42:29 | 显示全部楼层
感谢分享!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

发表于 2017-1-6 16:51:12 | 显示全部楼层
我找了它很久了。。。。。。。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 7525个

财富等级: 富甲天下

发表于 2017-1-7 07:15:37 | 显示全部楼层
回复学习学习,谢谢分享!!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-10-31 16:19 , Processed in 0.099629 second(s), 97 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表